#include "dwt_stm32_delay.h"

/**
 * @brief  Initializes DWT_Clock_Cycle_Count for Delay_us function
 * @return Error DWT counter
 *         1: clock cycle counter not started
 *         0: clock cycle counter works
 */
uint32_t Delay_Init(void) {
#if !defined(STM32F0xx)
	uint32_t c;
  /* Disable TRC */
  //CoreDebug->DEMCR &= ~CoreDebug_DEMCR_TRCENA_Msk; // ~0x01000000;
  /* Enable TRC */
  CoreDebug->DEMCR |=  CoreDebug_DEMCR_TRCENA_Msk; // 0x01000000;
  DWT->LAR = 0xC5ACCE55; 
	DWT->CYCCNT = 0;
  /* Disable clock cycle counter */
  //DWT->CTRL &= ~DWT_CTRL_CYCCNTENA_Msk; //~0x00000001;
  /* Enable  clock cycle counter */
  DWT->CTRL |=  DWT_CTRL_CYCCNTENA_Msk; //0x00000001;

  /* Reset the clock cycle counter value */
  //DWT->CYCCNT = 0;

  /* Check if DWT has started */
	c = DWT->CYCCNT;
	
	/* 2 dummys */
	__ASM volatile ("NOP");
	__ASM volatile ("NOP");
  /* Check if clock cycle counter has started */
	return (DWT->CYCCNT - c);
#else
	/* Return OK */
	return 1;
#endif
}

/* Use Delay_Init (); and Delay_us (microseconds) in the main */
