/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "adc.h"
#include "spi.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#ifdef __GNUC__
/* With GCC/RAISONANCE, small printf (option LD Linker->Libraries->Small printf
set to 'Yes') calls __io_putchar() */
#define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
#define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif /* __GNUC__ */

//#include "dwt_stm32_delay.h"
//#include "ds18b20.h"
#include "nRF24L01P.h"
#include <stdio.h>
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
nRF24L01P myNRF;
const uint8_t RXAddr[5] = {0x55, 0x55, 0x55, 0x55, 0x55};
const uint8_t TXAddr[5] = {0x55, 0x55, 0x55, 0x55, 0x55};
char TXData[8];

uint8_t RXBuffer[32], TXBuffer[32];
volatile uint8_t regStatus;
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
  int16_t adcval;
	float tempf;
  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_SPI1_Init();
  MX_USART2_UART_Init();
  MX_ADC1_Init();
  /* USER CODE BEGIN 2 */
	
  myNRF.hspi = &hspi1;														// You should make this definition at CubeMX
	myNRF.CRC_Width = nRF_CRC_WIDTH_HALFWORD;
	myNRF.ADDR_Width = nRF_ADDR_WIDTH_5;
	myNRF.Data_Rate = nRF_DATA_RATE_2MBPS;
	myNRF.TX_Power = nRF_TX_PWR_0dBm;
	myNRF.State = nRF_STATE_TX;

	myNRF.RF_Channel = 85;
	myNRF.PayloadWidth = nRF_RXPW_8BYTES;
	myNRF.RetransmitCount = nRF_RETX_DISABLED;
	myNRF.RetransmitDelay = nRF_RETX_DELAY_1000uS;

	myNRF.RX_Address = (uint8_t *)RXAddr;
	myNRF.TX_Address = (uint8_t *)TXAddr;

	myNRF.RX_Buffer = RXBuffer;
	myNRF.TX_Buffer = TXBuffer;

	myNRF.nRF_nSS_GPIO_PORT = nRF24_nSS_GPIO_Port;	// You should make this definition at CubeMX
	myNRF.nRF_nSS_GPIO_PIN = nRF24_nSS_Pin;					// You should make this definition at CubeMX

	myNRF.nRF_CE_GPIO_PORT = nRF24_CE_GPIO_Port;		// You should make this definition at CubeMX
	myNRF.nRF_CE_GPIO_PIN = nRF24_CE_Pin;						// You should make this definition at CubeMX
	
	if(HAL_nRF24L01P_Init(&myNRF) != HAL_OK)
	{
		printf("nRF24 Init fucked UP!\r\n");
		//Error_Handler();
	} else {
		printf("nRF24 Init is OK!\r\n");
	}
	
  /*DWT_Delay_Init();
	
	while(DS18B20_Init())               
	{
		printf ("DS18B20 Check Failed! Please Check!\r\n");
		HAL_Delay (500);		  
	}*/
		printf ("Application has started!\r\n");
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
		//temp=DS18B20_Get_Temp();
		HAL_ADC_Start(&hadc1);
		adcval = HAL_ADC_GetValue(&hadc1);
		tempf = adcval/12.4f;
		sprintf(TXData,"%8.1f",tempf);
		printf("Temperature:  *%s* degres\r\n",TXData);
		if(!myNRF.Busy)
		{
			if(HAL_nRF24L01P_TransmitPacket(&myNRF, (uint8_t *)TXData) != HAL_OK)
				//, nRF_DATA_PIPE_0
			{
				printf("There was something wrong!\n\r");
				//Error_Handler();
			}
		}	
	  printf("Data sent!\r\n");
  
		HAL_Delay(1000);
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage 
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE2);
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
  RCC_OscInitStruct.PLL.PLLM = 8;
  RCC_OscInitStruct.PLL.PLLN = 84;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */
PUTCHAR_PROTOTYPE
{
/* Place your implementation of fputc here */
/* e.g. write a character to the USART1 and Loop until the end of transmission */
HAL_UART_Transmit(&huart2, (uint8_t *)&ch, 1, 100);

return ch;
}
void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
	if(GPIO_Pin == nRF24_INT_Pin)
	{
		//printf("Interrupt OK!\n\r");
		if(HAL_nRF24L01P_IRQ_Handler(&myNRF) != HAL_OK)
		{
			Error_Handler();
		}
	 }
		//myNRF.Busy = 1;
		//HAL_nRF24L01P_ReadRegister(&myNRF, nRF_STATUS, &regStatus);
		//printf("Status >");
		//HAL_UART_Transmit(&huart1, &regStatus, 1, 250);
		//uartSent = 1;
 }
/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
